/************************** Dial Up Timer v0.4.1 ******************************
 *                              1998 PaGer                                    *
 *                    Wersja polska bez polskich znakow                       *
 ******************************************************************************/

#include <iostream.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <signal.h>
#include <sys/wait.h>
#include "ppidof.h"

// ======================== Zmienne globalne ==========================

    time_t start_time, current_time;		// Zmienne przechowywujace
						// start licznika i czas
						// terazniejszy

    int time_count;				// Odliczony czas
    int char_no=0;				// Numer znaku (funkcja wfc();)

// ====================== Konfiguracja DUTimer'a ======================

struct dut_config				// Tu przechowywana jest cala
						// konfiguracja DUTimera
{
    // ------------ Zmienne -------------

    int  wait,					// Czas oczekiwania na 
	 					// polaczenie
         mode,					// Tryb pracy

	 pppd,					// Obsluga pppd

	 no_copy,				// Mozliwosc uruchomienia
	                                        // wiecej niz jednej kopii
	
	 loop;					// Petla programu    

    double price;				// Cena impulsu w groszach

    char logfile[256];				// Nazwa pliku log
    
    // ------------ Funkcje -------------

    int search_str(char * buf, char * what);    // Szkuka nazwy pola
    
    int get_num(char * buf);			// Pobiera liczbe z pola
    
    void get_txt(char * buf, char * where);	// Pobiera tekst z pola

    void preinit();				// Ustawianie wartosci 
						// domyslnych
    void read_rc();				// Odczytywanie pliku rc

    void read_cmdl(int argc,char * argv[]);	// Odczytywanie linii komend

    void init();				// Initializacja

    void wait_for_pppd();			// Oczekiwanie na proces pppd

};

// -------------------------------------------------------------------

int dut_config::search_str(char * buf, char * what) 
						// Szuka nazwy pola
{
    int is=0,count=0,bad=0;
    for(int wherenow=0;(wherenow<255) & (is!=1);wherenow++)
						// Przeszukiwanie bufora
    {
	if(buf[wherenow]==what[0])
						// Jezeli znaleziono 1 znak...
	{
	    count=1;				// to szukaj nastepnych
	    for(int num=1;num<=strlen(what);num++)
		if(buf[wherenow+num]==what[num]) count++;
	    if (count==strlen(what)) is=1;	// jezeli znaleziono wszystkie
						// is=1
	}
	else if(buf[wherenow]!=' ') bad=1;	// Lecz jezeli jednak pierwszy
						// znak jest inny, to nazwa pola
						// sie nie zgadza
    }
    if(bad==0) return is; 
	else return 0;
}

// -------------------------------------------------------------------

void dut_config::get_txt(char * buf, char * where)	
						// Zwraca wartosc tekstowa pola
{
    int charnum=0,
	numintxt=0;

    while(buf[charnum]!='=') charnum++;		// Szuka znaku =
    charnum++;
    while(buf[charnum]==' ') charnum++;		// Szuka tekstu
    while(buf[charnum]!=10)			// Dopoki nie ma EOL...
    {
	where[numintxt]=buf[charnum];		// pobieraj tekst
	charnum++;
	numintxt++;
    }
    where[numintxt]='\0';			// Zakoncz tekst
}

// -------------------------------------------------------------------

int dut_config::get_num(char * buf)
						// Pobiera wartosc liczbowa pola
{
    int charnum=0,
	numintxt=0;
    char text[256];

    while(buf[charnum]!='=') charnum++;		// Szukaj znaku =
    charnum++;
    while(buf[charnum]==' ') charnum++;		// Szukaj liczby
    if ( !((buf[charnum]>=48) & (buf[charnum]<=57)) )
    {
	cout << "Blad w pliku rc:\n";
	cout << buf << '\n';
	exit(0);				// Jezeli wartosc nie jest
	                    			// liczba to wyjdz
    };
    while( ( (buf[charnum]>=48) & (buf[charnum]<=57) ) )
    {
	text[numintxt]=buf[charnum];		// Pobieraj liczbe jako tekst
	charnum++;
	numintxt++;
    }
    text[numintxt]='\0';
    int number=atoi(text);			// Zamien tekst w liczbe
    return number;
}

// -------------------------------------------------------------------

void dut_config::preinit()		
    // Ustawianie wartosci domyslnych:

{
    price=23;					// cena impulsu = 23 grosze,

    wait=7;					// oczekiwanie = 7 sekund,

    mode=1;					// tryb pracy = normalny,

    pppd=1;					// ze sprawdzaniem pppd,

    loop=0;					// bez petli,

    no_copy=1;					// tylko jedna kopia,

    logfile[0]='\0';				// bez logowania

    cout << " ok.";				// Skonczone.
};

// -------------------------------------------------------------------

void dut_config::read_rc()
    // Odczytywanie pliku rc

{
    int fhan,					// Uchwyt pliku rc

	count=0,				// Zmienna pomocnicza
	everyth=0;				// Zmienna pomocnicza

    char fpatch[256];				// Sciezka do pliku rc

    char buffer[256];				// Bufor do odczytu pliku rc
        
						// Przygotowanie do otwarcia:
    strcpy(fpatch,getenv("HOME"));		// pobranie katalogu domowego
    if((fpatch[0]=='/') && (fpatch[1]=='\0')) strcpy(fpatch,"/etc/dutimerrc");
						// Jezeli nie ma katalogu 
						// domowego (bo start z pliku
						// rc) - sciezka to /etc
    else
    {
	strcat(fpatch,"/");			// dodanie '/'
	strcat(fpatch,".dutimerrc");		// dodanie nazwy pliku rc
    }
    cout << '(' << fpatch << ")... ";		// wyswietlenie nazwy pliku rc
    
    fhan=open(fpatch,O_RDONLY);			// Otwarcie pliku rc

    if (fhan!=-1)
    {
	while (!everyth)			// Dopoki nie wczytasz 
						// wszystkiego
	{
	    for (int i=0;i<256;i++) buffer[i]=0;// Czyszczenie bufora
	
	    count=1;				// Odczytanie pierwszego znaku
	    read(fhan,buffer,1);		// z wiersza pliku rc
	
	    while(buffer[count-1]!=10)		// Odczytanie reszty wiersza
	    {
		read(fhan,buffer+count,1);
		count++;
	    }
	
	    if(!search_str(buffer,"#"))		// Jezeli to nie komentarz:
	
		if(search_str(buffer,"&end")) everyth=1;
		else				// Jezeli jest to znacznik 
						// konca, to koncz
	
		  if(search_str(buffer,"Wait")) wait=get_num(buffer);
		  else				// Jezeli to pole wait
						// to ustaw opoznienie

		    if(search_str(buffer,"Price")) price=get_num(buffer);
		    else			// Jezeli to pole price
						// to ustaw cene

		      if(search_str(buffer,"Log")) get_txt(buffer,logfile);
		      else			// Jezeli to pole log
		                                // to ustaw nazwe pliku log 
	
		        if(search_str(buffer,"Mode")) mode=get_num(buffer);
		        else			// Jezeli to pole mode
						// to ustaw tryb pracy
						
		          if(search_str(buffer,"PPPd")) pppd=get_num(buffer);
		          else			// Jezeli to pole PPPd
			                        // to ustaw obsluge PPPd'a

		              if(search_str(buffer,"Loop")) loop=get_num(buffer);
    		              else		// Jezeli to pole Loop
			                        // to ustaw opcje petli
		                  if(search_str(buffer,"No_Copy")) no_copy=get_num(buffer);
    		                  else		// Jezeli to pole No_Copy
			                        // to ustaw opcje
	
			          {
			              cout << "Blad w pliku rc:\n";
			              cout << buffer << '\n';
			              exit(0);	// Jezeli pole nie jest znane
			                        // to wyjdz
			          };
		
	}    
	
        close(fhan);				// Zamkniecie pliku rc

	cout << "ok.";				// Skonczone.

    }
    else cout << "brak.";			// Nie ma pliku ~/.dutimerrc
    
};

// -------------------------------------------------------------------

void dut_config::read_cmdl(int argc, char * argh[])
						// Odczytywanie linii komend

{
    if(argc>1) 					// Jezeli sa opcje
    {

	int current_nr=1;
	while (current_nr<argc)			// to sa analizowane
	{

	    if((argh[current_nr][0]=='-') & (argh[current_nr][1]=='w'))
	    {					// Wczytanie opoznienia
		if(argc-current_nr==1)
		{
		    cout << " Blad w linii komend: brak parametru dla opcji -w";
		    exit (0);
		}
		wait=atoi(argh[current_nr+1]);
		current_nr=current_nr+2;

	    } else

	    if((argh[current_nr][0]=='-') & (argh[current_nr][1]=='m'))
	    {					// Wczytanie trybu pracy

		if(argc-current_nr==1)
		{
		    cout << " Blad w linii komend: brak parametru dla opcji -m";
		    exit (0);
		}
		mode=atoi(argh[current_nr+1]);
		current_nr=current_nr+2;

	    } else

	    if((argh[current_nr][0]=='-') & (argh[current_nr][1]=='c'))
	    {					// Bez obslugi PPPd

		pppd=0;
		current_nr=current_nr+1;

	    } else

	    if((argh[current_nr][0]=='-') & (argh[current_nr][1]=='l'))
	    {					// Bez petli

		loop=0;
		current_nr=current_nr+1;

	    } else

	    if((argh[current_nr][0]=='-') & (argh[current_nr][1]=='L'))
	    {					// Z petla

		loop=1;
		current_nr=current_nr+1;

	    } else

	    if((argh[current_nr][0]=='-') & (argh[current_nr][1]=='C'))
	    {					// Z obsluga PPPd

		pppd=1;
		current_nr=current_nr+1;

	    } else

	    if((argh[current_nr][0]=='-') & (argh[current_nr][1]=='n'))
	    {					// Tylko jedna kopia programu

		no_copy=1;
		current_nr=current_nr+1;

	    } else

	    if((argh[current_nr][0]=='-') & (argh[current_nr][1]=='N'))
	    {					// Wiecej niz jedna kopia 

		no_copy=0;
		current_nr=current_nr+1;

	    } else

	    if((argh[current_nr][0]=='-') & (argh[current_nr][1]=='p'))
	    {					// Wczytanie ceny impulsu

		if(argc-current_nr==1)
		{
		    cout << " Blad w linii komend: brak parametru dla opcji -p";
		    exit (0);
		}
		price=atoi(argh[current_nr+1]);
		current_nr=current_nr+2;

	    } else

	    if((argh[current_nr][0]=='-') & (argh[current_nr][1]=='f'))
	    {					// Wczytanie nazwy pliku log

		if(argc-current_nr==1)
		{
		    cout << " Blad w linii komend: brak parametru dla opcji -f";
		    exit (0);
		}
		strcpy(logfile,argh[current_nr+1]);
		current_nr=current_nr+2;

	    } else
	    {
		cout << " Blad w linii komend: nieznana komenda ";
						// Nieznana komenda
		cout << argh[current_nr] << '\n';
		exit(0);
	    }
	}

	cout << " ok.";				// Wszystkie opcje wczytane

    } 
    else

    {

	cout << " brak.";			// Nie ma opcji w linii polecen

    }

};

// -------------------------------------------------------------------

void dut_config::init()
						// Initializacja
{
    ppidof("dutimer",1);
    if((ppidof("dutimer",0)!=-1) && (no_copy==1))
    {
	cout << " znaleziona druga kopia - koniec.\n";
	exit(0);
    }
    cout << " ok.";
};

// -------------------------------------------------------------------

void wfc_proc(int sig)				// Wymagane przez wait_for_pppd
{
    signal(sig,wfc_proc);
};

void dut_config::wait_for_pppd()
						// Oczekiwanie na proces pppd
{
    signal(SIGALRM,wfc_proc);
    while(ppidof("pppd",1)<=0)			// Co sekunde sprawdzana jest
    {						// obecnosc pppd
	alarm(1);
	pause();
    }
    cout << " znaleziony.";
};

dut_config config;				// Konfiguracja DUTimer'a

// =========================== Licznik czasu =========================

struct dut_timer				// Funkcje licznika
{

    // --------- Funkcje ---------

    int is_pppd();    				// Sprawdza obecnosc pppd

    void go();					// Start licznika

    void wait_for_connect();			// Oczekiwanie na polaczenie

};

// -------------------------------------------------------------------

int dut_timer::is_pppd()			// Sprawdza obecnosc pppd
{
    int zwrot=0;
    if( (config.pppd) & (config.mode==1) )
	if(ppidof("pppd",1)>0) zwrot=1;
	else zwrot=0;
    else zwrot=1;
    return zwrot;
}

// -------------------------------------------------------------------

void cnt(int sig)				// Wymagany przez dut_timer::go
{
    current_time=time(NULL);			// Odczytanie biezacego czasu
			    
    time_count=current_time-start_time;		// Obliczenie stanu licznika

    div_t time1,time2; 				// Zmienne do obliczenia czasu

    time1=div(time_count,3600);			// Przeksztalcenie czasu w
    time2=div(time1.rem,60);		        // sekundach na format gg:mm:ss
	    
    cout << "\r";

    if(time1.quot<10) cout << '0';		// Wyswietlenie czasu i 
    cout << time1.quot << ':';			// obliczenie kosztow
    if(time2.quot<10) cout << '0';
    cout << time2.quot << ':';
    if(time2.rem<10) cout << '0';
    cout << time2.rem;

    double il_impulsow=div(time_count,180).quot+1;

    cout << " ("<< il_impulsow << " impuls(ow) = ";
    cout << il_impulsow*config.price/100 <<" PLN)";

    signal (sig,cnt);
    cout << flush;
}

// -------------------------------------------------------------------

void dut_timer::go()				// Uruchomienie licznika
{
    if(config.mode==1)				// Pierwszy tryb pracy:
						// 'On-Line'
    {
	cout << "\nCzas od nawiazania polaczenia:\n";

	signal(SIGALRM,cnt);			// Ustawienie funkcji liczacej

        start_time=time(NULL);			// Pobranie czasu startu
    
        while(is_pppd())
        {
	    alarm(1);				// Odliczanie...
    	    pause();				
        }
    } 
    else if(config.mode==2)			// Drugi tryb pracy:
						// zapisanie czasu startu
    {
    
	cout << "\nZapisywanie czasu startu ";
	
        char fpatch[256];			// Sciezka do pliku dat
        
						// Przygotowanie do otwarcia:
        strcpy(fpatch,getenv("HOME"));		// pobranie katalogu domowego
	strcat(fpatch,"/");			// dodanie '/'
	strcat(fpatch,".dutimerdat");		// dodanie nazwy pliku dat

	cout << '(' << fpatch << ")...";

	start_time=time(NULL);			// Pobranie czasu
	
	char buf[10];
	
	gcvt(start_time,9,buf);			// Przeksztalcenie na lancuch
						// znakowy
	
	int f=open(fpatch,O_WRONLY|O_CREAT,00600);
						// Otworzenie pliku z czasem
	if (f==-1)
	{
	    cout << "Blad otwierania pliku!\n";
	    exit(0);
	};	

	write(f,buf,9);				// Zapisanie czasu
    	
	close(f);				// Zamkniecie pliku
	
	cout << " ok.";
    }
    else if(config.mode==3)			// Trzeci tryb pracy:
						// obliczenie czasu polaczenia
						// z uwzglednieniem zapisanego
						// czasu startu (tryb 2)
    {
	
	cout << "\nOdczytywanie czasu startu ";

        char fpatch[256];			// Sciezka do pliku dat
        
						// Przygotowanie do otwarcia:
        strcpy(fpatch,getenv("HOME"));		// pobranie katalogu domowego
	strcat(fpatch,"/");			// dodanie '/'
	strcat(fpatch,".dutimerdat");		// dodanie nazwy pliku rc

	cout << '(' << fpatch << ")...";

	
	current_time=time(NULL);		// Pobranie biezacego czasu
	
	char buf[10];
	
	int f=open(fpatch,O_RDONLY);		// Otwarcie pliku z czasem 
						// startu
	if (f==-1)
	{
	    cout << "Blad otwierania pliku!\n";
	    exit(0);
	};	
	
	read(f,buf,9);				// Odczytanie czasu startu
    	
	buf[10]='\0';
	
	close(f);				// Zamkniecie pliku
	
	
	start_time=atol(buf);			// Obliczenie i wyswietlenie 
						// czasu i kosztow:

	time_count=current_time-start_time;
	
	if(time_count>config.wait)
	{
	    time_count=time_count-config.wait;
	
    	    div_t time1,time2; 			// Zmienne do obliczenia czasu

	    time1=div(time_count,3600);		// Przeksztalcenie czasu w 
	    time2=div(time1.rem,60);		// sekundach na format gg:mm:ss

	    cout << " ok.\nCzas od nawiazania polaczenia: ";
	    
    	    if(time1.quot<10) cout << '0';
	    cout << time1.quot << ':';
    	    if(time2.quot<10) cout << '0';
    	    cout << time2.quot << ':';
    	    if(time2.rem<10) cout << '0';
    	    cout << time2.rem;

	    double il_impulsow=div(time_count,180).quot+1;

    	    cout << " ("<< il_impulsow << " impuls(ow) = ";
    	    cout << il_impulsow*config.price/100 <<" PLN)";
	}
	else cout << "\nPolaczenie nie zostalo jeszcze zrealizowane.";

    }
    else cout << "\nBlad! Nieznany tryb pracy (" << config.mode << ").";
};

// -------------------------------------------------------------------

void wfc(int sig)				// Funkcja wymagana przez
						// wait_for_connect,
						// odlicza czas
{
    char chars[4];				// Ustawienie znakow do
    chars[0]='/';				// wyswietlenia...
    chars[1]='-';
    chars[2]='\\';
    chars[3]='|';

    current_time=time(NULL);			// Pobranie czasu
    
    time_count=current_time-start_time;		// Obliczanie czasu...
    
    cout << "\b" << chars[char_no] << flush;	// Wyswietlenie znaku
    char_no++;
    if(char_no==4) char_no=0;
    
    signal(sig,wfc);
};

// -------------------------------------------------------------------

void dut_timer::wait_for_connect()		// Odliczanie do polaczenia
{
    signal(SIGALRM,wfc);			// Ustawienie funkcji odliczania
    
    cout << "|" << flush;
    
    start_time=time(NULL);			// Pobranie czasu startu
    
    for(time_count=0;time_count<config.wait;)
    {
	alarm(1);				// Odliczanie...
	pause();				
    }
    cout << "\bok.";
};

dut_timer timer;				// Licznik czasu


// ======================= Glowna czesc programu =====================


void main(int argc, char * argv[])
{
    cout << "\nDial Up Timer v0.4.1";
    cout << "\n1998 PaGer";
    cout << "\n----";
    cout << "\nInit:";
    cout << "\n - Ustawianie wartosci domyslnych...";
    config.preinit();
    cout << "\n - Odczytywanie pliku rc ";
    config.read_rc();
    cout << "\n - Odczytywanie linii komend...";
    config.read_cmdl(argc,argv);
    cout << "\n - Ustawianie opcji konfiguracyjnych...";
    config.init();
    int looping=1;
    while(looping)
    {
	start_time=0;
	current_time=0;
	time_count=0;
	if( (config.pppd) && (config.mode==1))
        {
	    cout << "\n - Oczekiwanie na proces pppd..." << flush;
	    config.wait_for_pppd();
        }
        if( (config.wait) && (config.mode==1) )
	{
    	    cout << "\n - Oczekiwanie do nawiazania polaczenia (" << config.wait;
	    cout << " sekund)... ";
	    timer.wait_for_connect();
        }
	cout << "\n----";
        timer.go();
	if (config.mode==1) cout << "\nPolaczenie zostalo przerwane.";
	cout << "\n----";
	if((config.loop==0) | (config.mode!=1)) looping=0;
    }
    cout << "\nKoniec.";
    cout << "\n";
}

// -------------------------------------------------------------------

