/************************** Dial Up Timer v0.4.1 ******************************
 *                              1998 PaGer                                    *
 *                           English version                                  *
 ******************************************************************************/

#include <iostream.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <signal.h>
#include <sys/wait.h>
#include "ppidof.h"

// ======================== Global Variables ==========================

    time_t start_time, current_time;		// Here is counter start 
						// and current time

    int time_count;				// Time count
    int char_no=0;				// Number of char (for wfc();)

// ====================== DUTimer's Configuration ======================

struct dut_config				// Here is whole
						// DUTimer's config
{
    // ------------ Variables -------------

    int  wait,					// Time, that DUT must wait
	 					// for connection
         mode,					// Working mode

	 pppd,					// PPPd support

	 no_copy,				// No more than 1 copy at once

	 loop;					// Program loop

    double price;				// Impuls price

    char logfile[256];				// Log file name
    
    // ------------ Functions -------------

    int search_str(char * buf, char * what);    // Searches for field name
    
    int get_num(char * buf);			// Gets a number from a field
    
    void get_txt(char * buf, char * where);	// Gets text from a field

    void preinit();				// Sets all defaults
					
    void read_rc();				// Reads rc file

    void read_cmdl(int argc,char * argv[]);	// Reads commandline

    void init();				// Initialization

    void wait_for_pppd();			// Waits for PPPd to run

};

// -------------------------------------------------------------------

int dut_config::search_str(char * buf, char * what) 
						// Searches field name
{
    int is=0,count=0,bad=0;
    for(int wherenow=0;(wherenow<255) & (is!=1);wherenow++)
						// Search the buffer
    {
	if(buf[wherenow]==what[0])
						// If 1 char is found...
	{
	    count=1;				// ... search next
	    for(int num=1;num<=strlen(what);num++)
		if(buf[wherenow+num]==what[num]) count++;
	    if (count==strlen(what)) is=1;	// If all chars have been found
						// is=1
	}
	else if(buf[wherenow]!=' ') bad=1;	// But if the first char is 
						// wrong, field name is not
						// ==what
    }
    if(bad==0) return is; 
	else return 0;
}

// -------------------------------------------------------------------

void dut_config::get_txt(char * buf, char * where)	
						// Gets text from a field
{
    int charnum=0,
	numintxt=0;

    while(buf[charnum]!='=') charnum++;		// Search for '='
    charnum++;
    while(buf[charnum]==' ') charnum++;		// Search for text
    while(buf[charnum]!=10)			// Until there is no EOL...
    {
	where[numintxt]=buf[charnum];		// ... get the text
	charnum++;
	numintxt++;
    }
    where[numintxt]='\0';			// Terminate string
}

// -------------------------------------------------------------------

int dut_config::get_num(char * buf)
						// Gets a number from a field
{
    int charnum=0,
	numintxt=0;
    char text[256];

    while(buf[charnum]!='=') charnum++;		// Search for '='
    charnum++;
    while(buf[charnum]==' ') charnum++;		// Search for a number
    if ( !((buf[charnum]>=48) & (buf[charnum]<=57)) )
    {
	cout << "Error in rc file:\n";
	cout << buf << '\n';
	exit(0);				// If it is not a number
	                    			// then exit
    };
    while( ( (buf[charnum]>=48) & (buf[charnum]<=57) ) )
    {
	text[numintxt]=buf[charnum];		// Get the number as text
	charnum++;
	numintxt++;
    }
    text[numintxt]='\0';
    int number=atoi(text);			// Convert text into a number
    return number;
}

// -------------------------------------------------------------------

void dut_config::preinit()		
    // Sets defaults:

{
    price=23;					// Impuls price = 23 gr,

    wait=7;					// Wait = 7 seconds,

    mode=1;					// Working mode = normal,

    pppd=1;					// With PPPd sync,

    loop=0;					// With no loop

    no_copy=1;					// No more than 1 copy

    logfile[0]='\0';				// With no log

    cout << " ok.";				// Finished.
};

// -------------------------------------------------------------------

void dut_config::read_rc()
    // Reads rc file

{
    int fhan,					// Rc fiel handle

	count=0,				// Variable\ for internal
	everyth=0;				// Variable/ use only

    char fpatch[256];				// Patch to rc file

    char buffer[256];				// Buffer for reading rc file
        
						// Preparing to open file:
    strcpy(fpatch,getenv("HOME"));		// get home dir.
    if((fpatch[0]=='/') && (fpatch[1]=='\0')) strcpy(fpatch,"/etc/dutimerrc");
						// If there is no home dir 
						// (because of start from rc 
						// file) - patch is /etc
    else
    {
	strcat(fpatch,"/");			// add '/'
	strcat(fpatch,".dutimerrc");		// add rc file name
    }
    cout << '(' << fpatch << ")... ";		// display full rc file name
    
    fhan=open(fpatch,O_RDONLY);			// Open rc file

    if (fhan!=-1)
    {
	while (!everyth)			// Until it won't read everyth.
	{
	    for (int i=0;i<256;i++) buffer[i]=0;// Clear the buffer
	
	    count=1;				// Read first char of the line
	    read(fhan,buffer,1);		// from the rc file
	
	    while(buffer[count-1]!=10)		// Read the rest of the line
	    {
		read(fhan,buffer+count,1);
		count++;
	    }
	
	    if(!search_str(buffer,"#"))		// If it is not a comment:
	
		if(search_str(buffer,"&end")) everyth=1;
		else				// If it is an ending sequence
						// then finish the work
	
		  if(search_str(buffer,"Wait")) wait=get_num(buffer);
		  else				// If it is Wait field
						// then read the value

		    if(search_str(buffer,"Price")) price=get_num(buffer);
		    else			// If it is Price field
						// then get the value

		      if(search_str(buffer,"Log")) get_txt(buffer,logfile);
		      else			// If it is Lig field
		                                // then get file name
	
		        if(search_str(buffer,"Mode")) mode=get_num(buffer);
		        else			// If it is Mode field
						// then get working mode
						
		          if(search_str(buffer,"PPPd")) pppd=get_num(buffer);
		          else			// If it is PPPd field
			                        // then set PPPd support

		              if(search_str(buffer,"Loop")) loop=get_num(buffer);
    		              else		// If it is Loop field
			                        // then set the loop
		                  if(search_str(buffer,"No_Copy")) no_copy=get_num(buffer);
    		                  else		// If it is No_Copy field
			                        // then set up this option
	
			          {
			              cout << "Error in rc file:\n";
			              cout << buffer << '\n';
			              exit(0);	// If it is unknown field
			                        // then exit
			          };
		
	}    
	
        close(fhan);				// Close rc file

	cout << "ok.";				// Finished.

    }
    else cout << "none.";			// There is no ~/.dutimerrc file
    
};

// -------------------------------------------------------------------

void dut_config::read_cmdl(int argc, char * argh[])
						// Reads commandline

{
    if(argc>1) 					// If there are options
    {

	int current_nr=1;
	while (current_nr<argc)			// they are being analized
	{

	    if((argh[current_nr][0]=='-') & (argh[current_nr][1]=='w'))
	    {					// Get the wait value
		if(argc-current_nr==1)
		{
		    cout << " Error in commandline: Missing -w parameter";
		    exit (0);
		}
		wait=atoi(argh[current_nr+1]);
		current_nr=current_nr+2;

	    } else

	    if((argh[current_nr][0]=='-') & (argh[current_nr][1]=='m'))
	    {					// Get working mode

		if(argc-current_nr==1)
		{
		    cout << " Error in commandline: Missing -m parameter";
		    exit (0);
		}
		mode=atoi(argh[current_nr+1]);
		current_nr=current_nr+2;

	    } else

	    if((argh[current_nr][0]=='-') & (argh[current_nr][1]=='c'))
	    {					// Without PPPd support

		pppd=0;
		current_nr=current_nr+1;

	    } else

	    if((argh[current_nr][0]=='-') & (argh[current_nr][1]=='l'))
	    {					// Without loop

		loop=0;
		current_nr=current_nr+1;

	    } else

	    if((argh[current_nr][0]=='-') & (argh[current_nr][1]=='L'))
	    {					// With loop

		loop=1;
		current_nr=current_nr+1;

	    } else

	    if((argh[current_nr][0]=='-') & (argh[current_nr][1]=='C'))
	    {					// With PPPd support

		pppd=1;
		current_nr=current_nr+1;

	    } else

	    if((argh[current_nr][0]=='-') & (argh[current_nr][1]=='n'))
	    {					// Only 1 copy

		no_copy=1;
		current_nr=current_nr+1;

	    } else

	    if((argh[current_nr][0]=='-') & (argh[current_nr][1]=='N'))
	    {					// More than 1 copy

		no_copy=0;
		current_nr=current_nr+1;

	    } else

	    if((argh[current_nr][0]=='-') & (argh[current_nr][1]=='p'))
	    {					// Read impuls price

		if(argc-current_nr==1)
		{
		    cout << " Error in commandline: Missing -p parameter";
		    exit (0);
		}
		price=atoi(argh[current_nr+1]);
		current_nr=current_nr+2;

	    } else

	    if((argh[current_nr][0]=='-') & (argh[current_nr][1]=='f'))
	    {					// Read log file name

		if(argc-current_nr==1)
		{
		    cout << " Error in commandline: Missing -f parameter";
		    exit (0);
		}
		strcpy(logfile,argh[current_nr+1]);
		current_nr=current_nr+2;

	    } else
	    {
		cout << " Error in commandline: Unknown command";
						// Unknown command
		cout << argh[current_nr] << '\n';
		exit(0);
	    }
	}

	cout << " ok.";				// All options have been read

    } 
    else

    {

	cout << " none.";			// There are no cmdline options

    }

};

// -------------------------------------------------------------------

void dut_config::init()
						// Initialization
{
    ppidof("dutimer",1);
    if((ppidof("dutimer",0)!=-1) && (no_copy==1))
    {
	cout << " found second copy - exit.\n";
	exit(0);
    }
    cout << " ok.";
};

// -------------------------------------------------------------------

void wfc_proc(int sig)				// Required by wait_for_pppd
{
    signal(sig,wfc_proc);
};

void dut_config::wait_for_pppd()
						// Wait for PPPd process
{
    signal(SIGALRM,wfc_proc);
    while(ppidof("pppd",1)<=0)			// Check for PPPd presence
    {						// once / second
	alarm(1);
	pause();
    }
    cout << " present.";
};

dut_config config;				// DUTimer's configuration

// =========================== Time Counter =========================

struct dut_timer				// Counter
{

    // --------- Functions ---------

    int is_pppd();    				// Checks for PPPd presence

    void go();					// Counter start

    void wait_for_connect();			// Waits for connection

};

// -------------------------------------------------------------------

int dut_timer::is_pppd()			// Checks for PPPd presence
{
    int zwrot=0;
    if( (config.pppd) & (config.mode==1) )
	if(ppidof("pppd",1)>0) zwrot=1;
	else zwrot=0;
    else zwrot=1;
    return zwrot;
}

// -------------------------------------------------------------------

void cnt(int sig)				// Required by dut_timer::go
{
    current_time=time(NULL);			// Get current time
			    
    time_count=current_time-start_time;		// Count the time

    div_t time1,time2; 				// Variables for time counting

    time1=div(time_count,3600);			// Convert UNIX-like time format
    time2=div(time1.rem,60);		        // into hh:mm:ss format
	    
    cout << "\r";

    if(time1.quot<10) cout << '0';		// Display the time and  
    cout << time1.quot << ':';			// count connection costs
    if(time2.quot<10) cout << '0';
    cout << time2.quot << ':';
    if(time2.rem<10) cout << '0';
    cout << time2.rem;

    double il_impulsow=div(time_count,180).quot+1;

    cout << " ("<< il_impulsow << " impuls(es) = ";
    cout << il_impulsow*config.price/100 <<" PLN)";

    signal (sig,cnt);
    cout << flush;
}

// -------------------------------------------------------------------

void dut_timer::go()				// Run the counter
{
    if(config.mode==1)				// First mode:
						// 'On-Line'
    {
	cout << "\nConnected for:\n";

	signal(SIGALRM,cnt);			// Set the signal handler

        start_time=time(NULL);			// Get start time
    
        while(is_pppd())
        {
	    alarm(1);				// Counting...
    	    pause();				
        }
    } 
    else if(config.mode==2)			// Second working mode:
						// save the start time
    {
    
	cout << "\nSaving connection start time ";
	
        char fpatch[256];			// Patch to the dat file
        
						// Prepare to open:
        strcpy(fpatch,getenv("HOME"));		// get home dir.
	strcat(fpatch,"/");			// add '/'
	strcat(fpatch,".dutimerdat");		// add dat file name

	cout << '(' << fpatch << ")...";

	start_time=time(NULL);			// Get time
	
	char buf[10];
	
	gcvt(start_time,9,buf);			// Convert time into text
	
	int f=open(fpatch,O_WRONLY|O_CREAT,00600);
						// Open dat file
	if (f==-1)
	{
	    cout << "Error opening file!\n";
	    exit(0);
	};	

	write(f,buf,9);				// Save start time
    	
	close(f);				// Close dat file
	
	cout << " ok.";
    }
    else if(config.mode==3)			// Third working mode:
						// Count connection time
						// using saved (in mode 2)
						// start time
    {
	
	cout << "\nReading connection start time ";

        char fpatch[256];			// Patch to the dat file
        
						// Prepare to open:
        strcpy(fpatch,getenv("HOME"));		// get home dir.
	strcat(fpatch,"/");			// add '/'
	strcat(fpatch,".dutimerdat");		// add rc file name

	cout << '(' << fpatch << ")...";

	
	current_time=time(NULL);		// Get current time
	
	char buf[10];
	
	int f=open(fpatch,O_RDONLY);		// Open file with start time
	if (f==-1)
	{
	    cout << "Error opening file!\n";
	    exit(0);
	};	
	
	read(f,buf,9);				// Read start time
    	
	buf[10]='\0';
	
	close(f);				// Close dat file
	
	
	start_time=atol(buf);			// Count and display time and
						// costs:

	time_count=current_time-start_time;
	
	if(time_count>config.wait)
	{
	    time_count=time_count-config.wait;
	
    	    div_t time1,time2; 			// Variables for time counting

	    time1=div(time_count,3600);		// Convert UNIX-like time format
	    time2=div(time1.rem,60);		// into hh:mm:ss format

	    cout << " ok.\nConnected for: ";
	    
    	    if(time1.quot<10) cout << '0';
	    cout << time1.quot << ':';
    	    if(time2.quot<10) cout << '0';
    	    cout << time2.quot << ':';
    	    if(time2.rem<10) cout << '0';
    	    cout << time2.rem;

	    double il_impulsow=div(time_count,180).quot+1;

    	    cout << " ("<< il_impulsow << " impuls(es) = ";
    	    cout << il_impulsow*config.price/100 <<" PLN)";
	}
	else cout << "\nNot connected yet.";

    }
    else cout << "\nError! Unknown working mode (" << config.mode << ").";
};

// -------------------------------------------------------------------

void wfc(int sig)				// Required by 
						// wait_for_connect,
						// counts the time
{
    char chars[4];				// Chars to display
    chars[0]='/';				
    chars[1]='-';
    chars[2]='\\';
    chars[3]='|';

    current_time=time(NULL);			// Get current time
    
    time_count=current_time-start_time;		// Count connection time
    
    cout << "\b" << chars[char_no] << flush;	// Char display
    char_no++;
    if(char_no==4) char_no=0;
    
    signal(sig,wfc);
};

// -------------------------------------------------------------------

void dut_timer::wait_for_connect()		// Wait for connection
{
    signal(SIGALRM,wfc);			// Set the signal handler
    
    cout << "|" << flush;
    
    start_time=time(NULL);			// Get start time
    
    for(time_count=0;time_count<config.wait;)
    {
	alarm(1);				// Counting...
	pause();				
    }
    cout << "\bok.";
};

dut_timer timer;				// Time counter


// ======================= Main Program Part =====================


void main(int argc, char * argv[])
{
    cout << "\nDial Up Timer v0.4.1";
    cout << "\n1998 PaGer";
    cout << "\n----";
    cout << "\nInit:";
    cout << "\n - Setting defaults...";
    config.preinit();
    cout << "\n - Reading rc file options ";
    config.read_rc();
    cout << "\n - Reading commandline options...";
    config.read_cmdl(argc,argv);
    cout << "\n - Initializing...";
    config.init();
    int looping=1;
    while(looping)
    {
	start_time=0;
	current_time=0;
	time_count=0;
	if( (config.pppd) && (config.mode==1))
        {
	    cout << "\n - Waiting for PPPd..." << flush;
	    config.wait_for_pppd();
        }
        if( (config.wait) && (config.mode==1) )
	{
    	    cout << "\n - Waiting for a connection (" << config.wait;
	    cout << " seconds)... ";
	    timer.wait_for_connect();
        }
	cout << "\n----";
        timer.go();
	if (config.mode==1) cout << "\nDisconnected.";
	cout << "\n----";
	if((config.loop==0) | (config.mode!=1)) looping=0;
    }
    cout << "\nFinished.";
    cout << "\n";
}

// -------------------------------------------------------------------

